	OPT	P=68000,ATARI,AUTOPC,BDW,ODW,LOCALDOT
	OPT	CASE,NOCHKBIT,NOCHKIMM,NOCHKPC,NODEBUG
	OPT	EVEN,NOLIST,NOTYPE,WARN,O+,USER

	include	gemdos.i
	include	gemmacro.i

INTERVAL	equ	3000

	SECTION	DATA
myname	dc.b	"  WakeGEM IV",$00
gemname	dc.b	"AESSYS  ",$00

	SECTION	BSS
aespid	ds.w	1
quit	ds.w	1
stack	ds.b	$0100

	SECTION	TEXT
start	lea	stack+$0100,sp
	appl_init
	move.w	d0,-(sp)
	pea	(P_nice<<16|$0014).l
	bpl.s	.ok
	pea	(P_term<<16|$ffff).l
.ok	trap	#1
	addq.l	#$04,sp
	lea	gemname,a0
	move.l	a0,d0
	bsr	applfnd
	bmi.s	.exit
	swap	d0
	move.w	#-2,d0
	swap	d0
	bsr	applfnd
	lea	aespid,a0
	move.w	d0,(a0)
	bmi.s	.exit
	clr.w	-(sp)		; SIGNULL
	move.w	d0,-(sp)
	move.w	#P_kill,-(sp)
	trap	#1
	addq.l	#$06,sp
	tst.l	d0
	bmi.s	.exit
	lea	myname,a0
	menu_register	(sp),a0
	pea	$3.w
	move.w	#P_sigsetmask,-(sp)
	trap	#1
	addq.l	#$06,sp
	lea	term,a6
	moveq	#SIGINT,d0
	bsr.s	signal
	moveq	#SIGQUIT,d0
	bsr.s	signal
	moveq	#SIGTERM,d0
	bsr.s	signal
	lea	alarm,a6
	moveq	#SIGALRM,d0
	bsr.s	signal
.wait	pea	INTERVAL.w
	move.w	#T_malarm,-(sp)
	trap	#1
	move.w	#P_pause,-(sp)
	trap	#1
	addq.l	#$08,sp
	lea	quit,a0
	tst.w	(a0)
	beq.s	.wait
.exit	appl_exit
	clr.w	(sp)	; not -(sp), stuff already on stack
	trap	#1

term	lea	quit,a0
	st	(a0)
	rts

alarm	move.w	#SIGCONT,-(sp)
	move.w	aespid,-(sp)
	move.w	#P_kill,-(sp)
	trap	#1
	addq.l	#$06,sp
	tst.l	d0
	lea	quit,a0
	smi	(a0)
	rts

signal	move.l	a6,-(sp)
	move.w	d0,-(sp)
	move.w	#P_signal,-(sp)
	trap	#1
	addq.l	#$08,sp
	rts

applfnd	appl_find	d0
	rts

	include	aeslib.s
